#include <stdio.h>

#include <stdio.h>
#include <stdbool.h>
#include "myint.h"
#include "aki80.h"

#define MAX_TASK	2
typedef struct {
	uint8	now;			//݂̃^XNԍ
	uint	sp[MAX_TASK+1];
} TASK_DATA_t;

static TASK_DATA_t task_data;

#define STACK_SIZE	128
static char sp[MAX_TASK][STACK_SIZE];

typedef struct {
	uint iy;
	uint ix;
	uint hl;
	uint de;
	uint bc;
	uint af;
	uint pc;
} STACK_t;

#define INIT_STACK(stack)	(stack+STACK_SIZE-(sizeof(STACK_t)))

bool init_task(uchar no,void (*func)(void))
{
	uint *p;
	if(no==0)
		return false;
	p = (uint*)INIT_STACK(sp[no -1]);
	task_data.sp[no] = (uint)p;
	*p++ = 0;	//IY
	*p++ = 0;	//IX
	*p++ = 0;	//HL
	*p++ = 0;	//DE
	*p++ = 0;	//BC
	*p++ = 0;	//AF
	*p = (uint*)func;
	return true;
}

void SIOA_putc(uchar c);
/* Ɏs^XNsplԂ */
uint switch_sp(uint sp)
{
	uchar next = task_data.now + 1;
	if(next > MAX_TASK)
		next = 0;
#if 0
	xprintf(SIOA_putc, "%d\n\r", (int)task_data.now);
	while(SIOA_transmitNow())
		;
#endif
	task_data.sp[task_data.now] = sp;
	task_data.now = next;
	return task_data.sp[next];
}
